/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.costs;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.data.properties.RoadProperty;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkRoute;

public interface VehicularPropertyCostEstimator extends PropertyBenefitEstimator {
	default double calculateCostsIfKnown(RoadProperty pProperty) {
		return calculateCostsIfKnown(pProperty.getClass());
	}

	double calculateCostsIfKnown(Class<? extends RoadProperty> pProperty);

	double calculateCostsIfKnown(RoadProperty pProperty, RoadNetworkEdge pDecisionPoint, VehicleCostPreference pVehicle,
			RoadNetworkRoute pPath);

	default double calculateCostsIfUnknown(RoadProperty pProperty) {
		return calculateCostsIfUnknown(pProperty.getClass());
	}

	double calculateCostsIfUnknown(Class<? extends RoadProperty> pProperty);

	double calculateCostsIfUnknown(RoadProperty pProperty, RoadNetworkEdge pDecisionPoint,
			VehicleCostPreference pVehicle, RoadNetworkRoute pPath);

}
