/*
 * Copyright (c) 2005-2018 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


package de.tudarmstadt.maki.simonstrator.api.component.sensor.environment.data.properties;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;

/**
 * @author Bjoern Bueschke
 * @version 1.0 at 26.03.2018
 *
 */
public class HazardProperty extends AbstractRoadProperty {

	private final boolean _hazard;
	
	public HazardProperty(Location pLocation, RoadNetworkEdge pEdge, boolean pHazard) {
		super(pLocation, pEdge);
		_hazard = pHazard;
	}

	public boolean hasHazard() {
		return _hazard;
	}

	@Override
	public RoadProperty getDefaultProperty() {
		return new HazardProperty(getLocation(), getEdge(), false);
	}

	@Override
	public Object getValue() {
		return hasHazard();
	}

	@Override
	public boolean isDetourable() {
		return true;
	}

	@Override
	public HazardProperty clone() {
		return new HazardProperty(getLocation(), getEdge(), _hazard);
	}

}
