/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.vehicular.information;

import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;

/**
 * An information in a vehicular scenario is always associated with a location
 * and a creation time. Those properties are crucial to evaluate the existence
 * of an object.
 * 
 * @author Tobias Meuser
 * @version 1.0.0
 *
 */
public interface VehicularPointInformation<S extends Object> extends PointInformation<S> {

	/**
	 * The edge of an information is required to decide whether the event is on
	 * the route of a vehicle. This method is required additionally to
	 * getLocation() to avoid match matching.
	 * 
	 * @return The edge of the event.
	 */
	RoadNetworkEdge getEdge();
}
